/********************************************************/
/*		soft object deformation simurator				*/
/*										FEM model		*/
/*										ver.1.0		*/
/*			Last updata:2006/09/13	Takashi Ikuta		*/
/********************************************************/
/*	<<Updata Information>>							*/
/*	2̓mFς							*/
/*	΂߃GbWׂ͂̕čォE		*/
/*	Lumped Inertia Matrix Model						*/
/*	wide=1,height=1̏ꍇmFς			*/
/*	elastic,voigt,maxwell,and three-element model	*/
/*	V~[V̌oߎԕ\ǉ				*/
/*	V~[VvZʂ̍팸					*/
/*	compValueύX(vOC)(05/10/12)			*/
/*	ψʃvOǉ(05/10/12)				*/
/*	ψʁCO͈֐(05/10/13)			*/
/*	f[^擾Ԋuݒł悤ɂ(05/10/13)	*/
/*	ψʕێvOǉ(05/10/16)			*/
/*	2݂̂̌ύX\ɂ(05/10/20)		*/
/*	ڑs񐶐vOǉ(05/10/26)		*/
/*	iq_WCԍCOp`vf_ԍ		*/

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <windows.h>
#include <time.h>
#include "RK.h"
#include "data.h"
#include "func.h"
#include "geodata.h"
#include "structdata.h"

static int sel_b;

static void differential(int n, double x[], double t, double value[], struct geo_data geo)
{
	int q;
	static struct sys_data sys;	//VXeϐp\̐錾

	//----------ÓA͂̏--------------------------
	for(q=0;q<node_Num;q++)
	{
		sys.FexX[q]	= 0.0;		//Ox
		sys.FexY[q]	= 0.0;		//Oy
		sys.FX[q]	= 0.0;		//Op`vfό`ɂ锭x
		sys.FY[q]	= 0.0;		//Op`vfό`ɂ锭y
	}
	//------------------------------------------------------

	for(q=0;q<node_Num;q++)
	{
		sys.npx[q]	= x[2*q+(0*node_Num)];
		sys.npy[q]	= x[2*q+(0*node_Num+1)];
		sys.nsx[q]	= x[2*q+(2*node_Num)];
		sys.nsy[q]	= x[2*q+(2*node_Num+1)];
		sys.wlax[q]	= x[2*q+(4*node_Num)];
		sys.wlay[q]	= x[2*q+(4*node_Num+1)];
		sys.wmux[q]	= x[2*q+(6*node_Num)];
		sys.wmuy[q]	= x[2*q+(6*node_Num+1)];
	}
	for(q=0;q<wide+1;q++)
	{
		sys.LMX[q] = x[2*q+(8*node_Num)];
		sys.LMY[q] = x[2*q+(8*node_Num+1)];
	}
	//------<<select>>computing of model force(e_ɂ郂f͂̌vZCf̑I)----
	switch(sel_b)
	{
	case 1:
		viscoelastic_Force(geo,&sys);			//voigt
		break;
	case 2:
		viscoplastic_Force(value,geo,&sys);		//maxwell
		break;
	case 3:
		threeElement_Force(value,geo,&sys);		//three-element
		break;
	case 4:
		elastic_Force(geo,&sys);				//elastic
		break;
	default:
		printf("\nERROR! Prease ENTER the KEY from 1 to 4!\n");
		exit(1);
		break;
	}
	//--------------------------------------------------------------------------------------------
	
//	add_exforce(t,&sys);				//O͈֐(ψʂꍇ̓RgAEg邱) exforce.cpp
	compValue(x,value,t,geo,&sys);		//computing of analysis value								 compValue.cpp
	add_csmmove(value,t,&sys);			//ψʗp֐(O͂ꍇ̓RgAEg邱)	 constraintMove.cpp

	//-----------for debug----------------
	//if(x[node_Num*2-2]>=1000 || x[node_Num*2-2]<=-1000)
	if(sys.npy[node_Num]<-1000.0)
	{
		printf("ERROR\r");
	}
	//------------------------------------
}

void main()
{
	double	startTime	= timeGetTime();
	double	t, dt, tend, Time;
	double	x[NumVars]	= {0.0};
	long	kcnt;
	int		cnt			= 0;
	int		sel_a;
	int		sel_mesh;
	char	buf1[256];
	char	*filename	= "result.dat";
	char	*filename2	= "geodata.dat";
	char	*filename3	= "tridata.dat";
	FILE	*fd,*fg,*ft;
	
	if ((fd = fopen(filename,"w")) == NULL) {
		fprintf(stderr, "cannot open %s\n", filename);
		exit(1);
	}

	if ((fg = fopen(filename2,"w")) == NULL) {
		fprintf(stderr, "cannot open %s\n", filename2);
		exit(1);
	}

	if ((ft = fopen(filename3,"w")) == NULL) {
		fprintf(stderr, "cannot open %s\n", filename3);
		exit(1);
	}

	dt = s_time;	//sampling time

	// kcnt * dt = 10 [sec] 

	//	sʕ\p(p[^o)
	printf("Simulation of 2D soft object deformation of a rectangular object(FEM MODEL)\n");
	printf("Ver.%lf\n\n",version);
	printf("\tsimulation time\t: %d[s]\n",sim_time);
	printf("\tsampling time\t: %lf[s](%lf[ms])(Runge-Kutta-Method)\n",s_time,s_time*1000);
	printf("\tobject\t\t: %d~%d[mesh]\n\tnodes\t\t: %d\n",wide,height,node_Num);
	printf("\tobject size\t: %.0lf[mm]~%.0lf[mm]\n\n\n",wide*tri_wide*1000,height*tri_height*1000);
	printf("\tPoisson's ratio\t\t= %lf\n\tYoung's modulous\t= %lf\n\tViscous modulous\t= %lf\n\n",Nela,E,C);
	printf("\tmass\t\t= %lf[kg](nodal mass\t= %lf)\n\tdensity\t\t= %lf\n\n",MASS,MASS/(node_Num),D);
	printf("Select computing method(ENTER the number  1 or 2)\n1:Runge-Kutta-Fehelberg\n2:Runge-Kutta\n");
	printf("ENTER the number:");
	fgets(buf1,sizeof(buf1),stdin);
	sscanf(buf1,"%d",&sel_a);
	//------<<select>>computing method(lvZ@I)---------
	switch(sel_a)
	{
		case 1:
			printf("\nYou choose:\tRunge-Kutta-Fehelberg\n");
			break;
		case 2:
			printf("\nYou choose:\tRunge-Kutta\n");
			break;
		default:
			printf("\nERROR! Prease ENTER the 1 or 2 KEY!\n");
			exit(1);
			break;
	}
	//---------------------------------------------------------
	printf("\nSelect computing method(ENTER the number  from 1 to 4)\n1:Voigt\n2:Maxwell\n3:Three-Element\n4:Elastic\n");
	printf("ENTER the number:");
	fgets(buf1,sizeof(buf1),stdin);
	sscanf(buf1,"%d",&sel_b);
	//------<<select>>computing of model force(e_ɂ郂f͂̌vZCf̑I)----
	switch(sel_b)
	{
	case 1:
		printf("\nYou choose:\tVoigt\n\n");
		break;
	case 2:
		printf("\nYou choose:\tMaxwell\n\n");
		break;
	case 3:
		printf("\nYou choose:\tThree-Element\n\n");
		break;
	case 4:
		printf("\nYou choose:\tElastic\n\n");
		break;
	default:
		printf("\nERROR! Prease ENTER the KEY from 1 to 4!\n");
		exit(1);
		break;
	}
	//--------------------------------------------------------------------------------------------
	printf("Select mesh(ENTER the number  from 1 to 4)\n1:un-symmetry(right-down)\n2:un-symmetry(right-up)\n3:symmetry(type1)\n4:symmetry(type2)\n");
	printf("ENTER the number:");
	fgets(buf1,sizeof(buf1),stdin);
	sscanf(buf1,"%d",&sel_mesh);
	switch(sel_mesh)						//`̂̊iq_WCOp`vf̒_ԍW[-----
	{
	case 1:
		printf("un-symmetry(righ-down)\n");
		break;
	case 2:
		printf("un-symmetry(righ-up)\n");
		break;
	case 3:
		printf("symmetry(type 1)\n");
		break;
	case 4:
		printf("symmetry(type 2)\n");
		break;
	default:
		printf("ERROR!\n");
		exit(1);
		break;
	}
	printf("Start simulation\n");
	
	t		= 0.0;							// initial value
	tend	= sim_time;
	kcnt	= (int)(sim_time/dt);//1000;	//loop count

	static struct geo_data geo;				//􉽏p\̐錾
	
	switch(sel_mesh)						//`̂̊iq_WCOp`vf̒_ԍW[-----
	{
	case 1:
		make_GeoData_unsymmetry_left(fg, ft, &geo);
		break;
	case 2:
		make_GeoData_unsymmetry_right(fg, ft, &geo);
		break;
	case 3:
		make_GeoData_symmetry_type1(fg, ft, &geo);
		break;
	case 4:
		make_GeoData_symmetry_type2(fg, ft, &geo);
		break;
	default:
		printf("ERROR!\n");
		exit(1);
		break;
	}
	make_MatandArea(fg, &geo);				//Op`vf̕ڑsCʐρC[̒萔W[-----
	make_InertiaMat(&geo);					//eOp`̊švZ(lumped inertia matrix)----------------

	switch(sel_a)
	{
		case 1:
			RungeKuttaFehlbergAdaptivefprint(fd, NumVars, x, t, dt, &cnt);	// print initial values
			RungeKuttaFehlbergAdaptive(fd, NumVars, x, differential, &t, &dt, tend, kcnt, geo, &cnt);
			break;
		case 2:
			RungeKuttafprint(fd, NumVars, x, t);	// print initial values
			RungeKutta(fd, NumVars, x, differential, &t, dt, kcnt, geo);
			break;
		default:
			printf("\nERROR! Prease ENTER the 1 or 2 KEY!\n");
			exit(1);
			break;
	}

	Time = timeGetTime();
	printf("\n\n");
	printf("End of simulation\treal time:%lf[s]\n",(Time-startTime)/CLOCKS_PER_SEC);
	printf("time per 1 loop(ave.) = %lf[ms]\n",(Time-startTime)/(kcnt));		//Runge-Kutta 1[v̕ώԕ\[ms]

	fclose(fd);
	fclose(fg);
}

