#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <windows.h>
#include <time.h>
#include "RK.h"
#include "data.h"
#include "func.h"
#include "structdata.h"

void viscoelastic_Force (struct geo_data geo, struct sys_data *sys)
{
	int i,k = 0;
	int ti,tj,tk;
	double nptemp[6] = {0.0};
	double nstemp[6] = {0.0};
	
	for(i=0;i<tri_Num;i++)
	{
		ti = geo.triangle[i].point_i;
		tj = geo.triangle[i].point_j;
		tk = geo.triangle[i].point_k;

		nptemp[0] = sys->npx[ti];
		nptemp[1] = sys->npy[ti];
		nptemp[2] = sys->npx[tj];
		nptemp[3] = sys->npy[tj];
		nptemp[4] = sys->npx[tk];
		nptemp[5] = sys->npy[tk];

		nstemp[0] = sys->nsx[ti];
		nstemp[1] = sys->nsy[ti];
		nstemp[2] = sys->nsx[tj];
		nstemp[3] = sys->nsy[tj];
		nstemp[4] = sys->nsx[tk];
		nstemp[5] = sys->nsy[tk];

		for(k=0;k<6;k++)
		{
			sys->FX[ti] +=	geo.triangle[i].mat_lambda[0][k]*(geo.triangle[i].Lela*nptemp[k]+geo.triangle[i].Lvis*nstemp[k])+
						geo.triangle[i].mat_mu[0][k]*(geo.triangle[i].Mela*nptemp[k]+geo.triangle[i].Mvis*nstemp[k]);

			sys->FY[ti] +=	geo.triangle[i].mat_lambda[1][k]*(geo.triangle[i].Lela*nptemp[k]+geo.triangle[i].Lvis*nstemp[k])+
						geo.triangle[i].mat_mu[1][k]*(geo.triangle[i].Mela*nptemp[k]+geo.triangle[i].Mvis*nstemp[k]);

			sys->FX[tj] +=	geo.triangle[i].mat_lambda[2][k]*(geo.triangle[i].Lela*nptemp[k]+geo.triangle[i].Lvis*nstemp[k])+
						geo.triangle[i].mat_mu[2][k]*(geo.triangle[i].Mela*nptemp[k]+geo.triangle[i].Mvis*nstemp[k]);

			sys->FY[tj] +=	geo.triangle[i].mat_lambda[3][k]*(geo.triangle[i].Lela*nptemp[k]+geo.triangle[i].Lvis*nstemp[k])+
						geo.triangle[i].mat_mu[3][k]*(geo.triangle[i].Mela*nptemp[k]+geo.triangle[i].Mvis*nstemp[k]);

			sys->FX[tk] +=	geo.triangle[i].mat_lambda[4][k]*(geo.triangle[i].Lela*nptemp[k]+geo.triangle[i].Lvis*nstemp[k])+
						geo.triangle[i].mat_mu[4][k]*(geo.triangle[i].Mela*nptemp[k]+geo.triangle[i].Mvis*nstemp[k]);

			sys->FY[tk] +=	geo.triangle[i].mat_lambda[5][k]*(geo.triangle[i].Lela*nptemp[k]+geo.triangle[i].Lvis*nstemp[k])+
						geo.triangle[i].mat_mu[5][k]*(geo.triangle[i].Mela*nptemp[k]+geo.triangle[i].Mvis*nstemp[k]);
		}
	}
}
