#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <windows.h>
#include <time.h>
#include "RK.h"
#include "data.h"
#include "func.h"
#include "structdata.h"

void viscoplastic_Force (double value[],struct geo_data geo, struct sys_data *sys)
{
	int i,k,q = 0;
	int ti,tj,tk;
	double wlatemp[6] = {0.0};
	double wmutemp[6] = {0.0};
	
	for(i=0;i<tri_Num;i++)
	{
		ti = geo.triangle[i].point_i;
		tj = geo.triangle[i].point_j;
		tk = geo.triangle[i].point_k;

		wlatemp[0] = sys->wlax[ti];
		wlatemp[1] = sys->wlay[ti];
		wlatemp[2] = sys->wlax[tj];
		wlatemp[3] = sys->wlay[tj];
		wlatemp[4] = sys->wlax[tk];
		wlatemp[5] = sys->wlay[tk];

		wmutemp[0] = sys->wmux[ti];
		wmutemp[1] = sys->wmuy[ti];
		wmutemp[2] = sys->wmux[tj];
		wmutemp[3] = sys->wmuy[tj];
		wmutemp[4] = sys->wmux[tk];
		wmutemp[5] = sys->wmuy[tk];

		for(k=0;k<6;k++)
		{
			sys->FX[ti] +=	geo.triangle[i].mat_lambda[0][k]*wlatemp[k]+geo.triangle[i].mat_mu[0][k]*wmutemp[k];
			sys->FY[ti] +=	geo.triangle[i].mat_lambda[1][k]*wlatemp[k]+geo.triangle[i].mat_mu[1][k]*wmutemp[k];
			sys->FX[tj] +=	geo.triangle[i].mat_lambda[2][k]*wlatemp[k]+geo.triangle[i].mat_mu[2][k]*wmutemp[k];
			sys->FY[tj] +=	geo.triangle[i].mat_lambda[3][k]*wlatemp[k]+geo.triangle[i].mat_mu[3][k]*wmutemp[k];
			sys->FX[tk] +=	geo.triangle[i].mat_lambda[4][k]*wlatemp[k]+geo.triangle[i].mat_mu[4][k]*wmutemp[k];
			sys->FY[tk] +=	geo.triangle[i].mat_lambda[5][k]*wlatemp[k]+geo.triangle[i].mat_mu[5][k]*wmutemp[k];
		}
	}

	//ύXKv
	for(q=0;q<node_Num;q++)
	{
		value[2*q+(4*node_Num)]		= -(Lela/Lvis)*sys->wlax[q]+Lela*sys->nsx[q];
		value[2*q+(4*node_Num+1)]	= -(Lela/Lvis)*sys->wlay[q]+Lela*sys->nsy[q];
		value[2*q+(6*node_Num)]		= -(Mela/Mvis)*sys->wmux[q]+Mela*sys->nsx[q];
		value[2*q+(6*node_Num+1)]	= -(Mela/Mvis)*sys->wmuy[q]+Mela*sys->nsy[q];
	}
}